天天看點

POJ 3126 Prime Path (BFS)

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros). Output One line for each case, either with a number stating the minimal cost or containing the word Impossible. Sample Input

3
1033 8179
1373 8017
1033 1033      

Sample Output

6
7
0      

BFS,判斷素數可以提前素數篩打表也可以跑從1到sqrt(n)的循環,因為隻是四位數是以肯定不會TLE。

入隊方式我是開了方向數組,把每一位分别+(-9,-8,-7...-1,1,...8,9)然後看改動後是否合法。

改完的數要保證是四位數并且隻改了一位,沒有退位和進位。

剩下和普通BFS一樣,存步數即可。

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<queue>
#include<map>
#include<algorithm>
#include<iostream>
#define ll long long
#define ull long long
const int N=1e9+7;
const int M=1e6+5;
using namespace std;

int i,j,k,n,m;
int c[20]={-9,-8,-7,-6,-5,-4,-3,-2,-1,1,2,3,4,5,6,7,8,9};   //每一位的數字可以加這些數
int d[10005]; // 标記數組

struct node
{
    int x;
    int y;
};

bool check1(int x)  //判斷是不是素數
{
    bool flag=true;
    for(int i=2;i*i<=x;i++)
    {
       if(x%i==0)
       {
           flag=false;
           break;
       }
    }
    return flag;
}

bool check2(int x)  //判斷是否合法
{
    return x>=1000&&x<=9999&&!d[x];
}

int bfs() // 廣搜
{
    int e,f,z;
    memset(d,0,sizeof(d));
    queue<node>q;
    node a,b;
    a.x=n,a.y=0;
    q.push(a);
    d[n]=1;
    while(!q.empty())
    {
        a=q.front();
        q.pop();
        for(i=0;i<4;i++)
        {
            if(i==0) e=1;             //個位改動
            if(i==1) e=10;           //十位改動
            if(i==2) e=100;        //百位改動
            if(i==3) e=1000;      //千位改動
            for(j=0;j<18;j++)
            {
                f=a.x+e*c[j];
                z=a.x%(e*10)+e*c[j];
                if(z>=e*10||z<0) continue;  // 如果改動以後資料不是四位數 或者導緻改動的位數超過一位  則不合法
                if(check1(f)&&check2(f))
                {
                    b.x=f;
                    b.y=a.y+1;
                    if(b.x==m) return b.y;
                    d[f]=1;
                    q.push(b);
                }
            }
        }
    }
}

int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d",&n,&m);
        if(n==m)  //特判
        {
            printf("0\n");
            continue;
        }
        int ans=bfs();
        printf("%d\n",ans);
    }
    return 0;
}